// -*- MaTX -*-

// sim00004.mm: tmd00004.{h,mm} ΥƥȤΤΥߥ졼
//
//   Originally written by KIYOTA Hiromitsu <1999/01/01>
//   Copyright (c) 1999 Hiromitsu Kiyota, kiyota@ds.mei.titech.ac.jp
//
// RCS: $Id: sim00004.mm,v 1.5 1999/05/31 03:22:01 kiyota Exp $

// Local options
//#define NOPLOT
//#define MULTIPLOT

// These are required #definitions.
#define TMD00004_USER_H "sim00004.h"
#define TMD00004_USER_MM "sim00004.mm"

// TMD00004_USER_H  #include 롣
#include "tmd00004.h"

Matrix tmd00004(F); // ֥եɥХåΥ
// Ǿ֥Фη󤿤
Matrix tmd00004(Ah), tmd00004(Bh), tmd00004(Ch), tmd00004(Dh), tmd00004(Jh);

Func void
main()
{
  Matrix TC, XC, UC;
  Matrix link_eqs();
#ifndef NOPLOT
  List names;
  Integer i;
#ifdef MULTIPLOT
  Integer hmultiplot(...) require "hplot.mm";
#endif /* MULTIPLOT */
#endif /* ! NOPLOT */

//  init_tmd00004(1); // Υߥ졼
  init_tmd00004(); // Υߥ졼

  // /Ĵ¬ǤʤмԤǤ礦
#ifndef TMD00004_USER_DIFF
  tmd00004(F) = Optimal(tmd00004(A), tmd00004(B),
			diag([50000.0], [10000.0], [10000.0], [0.1]), [1.0]);
#else /* TMD00004_USER_DIFF */
  tmd00004(F) = PoleAssign(tmd00004(A), tmd00004(B),
			   [(-2,1), (-2,-1), (-4, 2), (-4, -2)]');
  {tmd00004(Ah), tmd00004(Bh), tmd00004(Ch), tmd00004(Dh), tmd00004(Jh)} =
    Gopinath(tmd00004(A), tmd00004(B), tmd00004(C), [(-10,1), (-10,-1)]');
#endif /* ! TMD00004_USER_DIFF */
  
  {TC, XC, UC} = Ode45Auto(0.0, 10.0,
#ifndef TMD00004_USER_DIFF
			   [5e-1, 0.0, -1e-1, 0.0]',
#else /* TMD00004_USER_DIFF */
			   [[5e-1, 0.0, -1e-1, 0.0],
			    [0.0, 0.0]]', // ưŪν
#endif /* ! TMD00004_USER_DIFF */
			   diff_tmd00004, link_eqs);
  print [[TC][XC][UC]] >> "sim.mat";

#ifndef NOPLOT
  names = {"phi(=y2)", "dot_phi", "z(=y1)", "dot_z", // XC
#ifdef TMD00004_USER_DIFF
	   "z1", "z2",
#endif /* TMD00004_USER_DIfF */
	   "u", "-", "-"}; // UC

#ifndef MULTIPLOT
   for (i = 1; i <= length(names); ++i)
     {
       if (names(i, String) == "-") { continue; }
       mgplot_grid(i, 1);
       mgplot(i, TC(1,:), [[XC][UC]](i,:), {names(i, String)});
     }
#else /* MULTIPLOT */
  hmultiplot(1, TC, [[XC][UC]], names);
#endif /* ! MULTIPLOT */
  pause;
#endif /* ! NOPLOT */
}


Func Matrix
link_eqs(t, xx)
     Real t;
     Matrix xx;
{
  Matrix uy;
  static Integer running;
  static Matrix u;
  Matrix x, y;
#ifdef TMD00004_USER_DIFF
  Matrix z, x_hat;
#endif /* TMD00004_USER_DIFF */

  if (running == 0) // ߥ졼󳫻ϻ
    {
      uy = Z(TMD00004_DIM_ALL_IOS,1);
      u = chop_input_tmd00004(uy);
      running = 1;
    }

  x = chop_state_tmd00004(xx);
  y = output_tmd00004(t, x, u);
#ifndef TMD00004_USER_DIFF
  u = tmd00004(F)*x;
#else /* TMD00004_USER_DIFF */
  z = chop_other_state_tmd00004(xx);
  x_hat = tmd00004(Ch)*z + tmd00004(Dh)*y;
  u = tmd00004(F)*x_hat;
#endif /* ! TMD00004_USER_DIFF */

  uy = [[u]
	[y]];
  return uy;
}


#ifdef TMD00004_USER_DIFF
// ưŪ: Gopinath κǾ֥
//    dz/dt = Ah*z + Bh*y + Jh*u  : here
//   (x_hat = Ch*z + Dh*y         : in link_eqs() above)
Func Matrix
TMD00004_USER_DIFF(t, xx, uu)
     Real t;
     Matrix xx, uu;
{
  Matrix x, u, y, z, dz; // z ϤǤϴ¬ξ

  x = chop_state_tmd00004(xx);
  u = chop_input_tmd00004(uu);
  y = output_tmd00004(t, x, u);
  z = chop_other_state_tmd00004(xx);

  dz = tmd00004(Ah)*z + tmd00004(Bh)*y + tmd00004(Jh)*u;

  return dz;
}
#endif /* TMD00004_USER_DIFF */
