/* -*- MaTX -*-
 *
 * tmd00004.mm: TMD No. tmd00004 (ľ졼ñΩ)Υǥ
 *
 *  Originally written by KIYOTA Hiromitsu <1999/01/01>
 *  Copyright (c) 1999 Hiromitsu Kiyota, kiyota@ds.mei.titech.ac.jp
 *
 * RCS: $Id: tmd00004.mm,v 1.8 1999/06/29 03:46:34 kiyota Exp $
 */

#ifndef _TMD00004_MM
#define _TMD00004_MM

#ifndef TMD_EXTERN
#define TMD_EXTERN extern
#endif /* ! TMD_EXTERN */
#include "tmd00004.h"

// some definitions for local alist
#define _TMD_LALIST {"_tmd00004"}
#define _TMD_LIN_FLAG "linear_flag"

// just for simplicity... B)
#define tmd4(var) tmd00004(var)

Func void
init_tmd00004(linear_flag, params_flag, ...)
     Integer linear_flag, params_flag;
{
#ifndef TMD00004_DISABLE_HALIST
  List halist(...);
#endif /* ! TMD00004_DISABLE_HALIST */
  Real D;

  switch (nargs)
    {
    case 2:
      break;
    case 0:
      linear_flag = 0; // ǥե: ǥ
    case 1:
      params_flag = 0; // ǥե: ѥ᡼̤
      break;
    default:
      error("init_tmd00004(): Incorrect number of arguments. (nargs=%d)\n", nargs);
      break;
    }
  
  // ()Υե饰
#ifndef TMD00004_DISABLE_HALIST
  if (halist({_TMD_LALIST, "exists"}) == {})  // if not exist
    {
      halist({_TMD_LALIST, "clear"});  // new alist
    }
  halist(_TMD_LALIST, {{_TMD_LIN_FLAG, linear_flag}});
#else /* TMD00004_DISABLE_HALIST */
  tmd00004_flag = linear_flag;
#endif /* ! TMD00004_DISABLE_HALIST */

  if (params_flag == 0)
    {
      tmd4(J) = 1.67e-3; /* kgm^2 */	// Ҥνſޤδ⡼
      tmd4(mu) = 1.80e1; /* kg/s */	// ַϤ໤
      tmd4(c) = 7.26e-4; /* kg/s */	// Ǵ໤
      tmd4(l) = 1.15e-1; /* m */	// 鿶ҤνſޤǤεΥ
      tmd4(m) = 0.1; /* kg */		// Ҥμ
      tmd4(M) = 4.81; /* kg */		// ֤
      tmd4(a) = 20.09; /* N/V */	// Űȥ륯Ѵ
      tmd4(c1) = 3.34; /* V/rad */	// ١ŰѴ
      tmd4(c2) = 21.7; /* V/m */	// ֡ŰѴ
      tmd4(g) = 9.8; /* m/s^2 */	// ϲ®
    }

  D = tmd4(m)^2*tmd4(l)^2 - (tmd4(M) + tmd4(m))*(tmd4(J) + tmd4(m)*tmd4(l)^2);
  tmd4(A) =
    [[0.0, D /* 1.0 (typo) */, 0.0, 0.0]
     [-(tmd4(M) + tmd4(m))*tmd4(m)*tmd4(g)*tmd4(l),
      (tmd4(M) + tmd4(m))*tmd4(c), 0.0, -tmd4(m)*tmd4(l)*tmd4(mu)]
     [0.0, 0.0, 0.0, D /* 1.0 (typo) */]
     [tmd4(m)^2*tmd4(g)*tmd4(l)^2, -tmd4(m)*tmd4(l)*tmd4(c), 0.0,
      (tmd4(J) + tmd4(m)*tmd4(l)^2)*tmd4(mu)]]/D;
  tmd4(B) =
    [0.0, tmd4(m)*tmd4(l)*tmd4(a), 0.0, -(tmd4(J) + tmd4(m)*tmd4(l)^2)*tmd4(a)]'/D /* no /D (typo) */;
  tmd4(C) = [[tmd4(c1), 0.0, 0.0, 0.0]
	     [0.0, 0.0, tmd4(c2), 0.0]];
}


Func Matrix
diff_tmd00004(t, xx, uu)
     Real t;
     Matrix xx, uu;
{
  Matrix dxx;
#ifndef TMD00004_DISABLE_HALIST
  List halist(...);
#endif /* ! TMD00004_DISABLE_HALIST */
  Matrix dx, x, u;
#ifdef TMD00004_USER_DIFF
  Matrix TMD00004_USER_DIFF();
#endif /* TMD00004_USER_DIFF */
  Real Delta;

  x = chop_state_tmd00004(xx);
  u = chop_input_tmd00004(uu);
  
#ifndef TMD00004_DISABLE_HALIST
  if (halist(_TMD_LALIST, {_TMD_LIN_FLAG}) == {0}) // ǥ
#else /* TMD00004_DISABLE_HALIST */
  if (tmd00004_flag == 0) // ǥ
#endif /* ! TMD00004_DISABLE_HALIST */
    {
      Delta = ((tmd4(m)*tmd4(l)*cos(x(1)))^2
	       - (tmd4(M) + tmd4(m)) * (tmd4(J) + tmd4(m)*tmd4(l)^2));
      dx = [x(2),
	    (-(tmd4(M) + tmd4(m))*tmd4(m)*tmd4(g)*tmd4(l)*sin(x(1))
	     + (tmd4(M) + tmd4(m))*tmd4(c)*x(2) - tmd4(m)*tmd4(l)*tmd4(mu)*x(4)
	     + tmd4(m)^2*tmd4(l)^2*x(2)*sin(x(1))*cos(x(1))
	     + tmd4(m)*tmd4(l)*tmd4(a)*u(1)*cos(x(1)))/Delta,
	    x(4),
	    (tmd4(m)^2*tmd4(g)*tmd4(l)^2*sin(x(1))*cos(x(1))
	     - tmd4(m)*tmd4(l)*tmd4(c)*x(2)*cos(x(1))
	     + (tmd4(J) + tmd4(m)*tmd4(l)^2)*tmd4(mu)*x(4)
	     - tmd4(m)*tmd4(l)*(tmd4(J)+ tmd4(m)*tmd4(l)^2)*x(2)*sin(x(1))
	     - (tmd4(J) + tmd4(m)*tmd4(l)^2)*tmd4(a)*u(1))/Delta]';
    }
  else // ǥ
    {
      dx = tmd4(A)*x + tmd4(B)*u;
    }

  dxx = [[dx]
#ifdef TMD00004_USER_DIFF
	 [TMD00004_USER_DIFF(t, xx, uu)]
#endif /* TMD00004_USER_DIFF */
	 ];
  return dxx;
}


Func Matrix
output_tmd00004(t, xx, uu)
     Real t;
     Matrix xx, uu;
{
  Matrix x, u, y;

  x = chop_state_tmd00004(xx);
  u = chop_input_tmd00004(uu);

  y = tmd4(C)*x;

  return y;
}

#undef tmd4
#undef _TMD_LALIST
#undef _TMD_LIN_FLAG

#endif /* !_TMD00004_MM */
